// FaculteKeypad.java
// 01.03.96
//
// the keypad on the faculte screen

package cybcerone.faculte;

import cybcerone.utils.Appletlike;
import cybcerone.utils.Keypad;

/**
 * A keypad with the image and buttons defined for the facultes screen.
 */
class FaculteKeypad extends Keypad {
  private static final String id = "faculteKeypad";
  private static final String statusText = "Select faculty or services";

  private static final String bgFile =
    FacultePanel.imagePath + "fond_facultes.gif";
  private static final String activeBgFile =
    FacultePanel.imagePath + "fond_facultes_rouge.gif";

  FaculteKeypad (Appletlike app) {
    super (id, statusText, app);

    setBackground (bgFile, 7);
    setActiveBackground (activeBgFile, 7);

    makeButtons ();
    reset ();
  }

  public void reset () {
    update (whichButton ("Lettres"));  /* push the Lettres button */
  }

  /** Set those buttons up. */
  private void makeButtons () {
    addButton ("Rectorat",  30, 203, 229, 50);

    addButton ("Theologie", 30, 253, 114, 50);
    addButton ("Droit",     145, 253, 114, 50);
    addButton ("Lettres",   30, 302, 114, 50);
    addButton ("Sciences sociales et politiques",
                                             145, 302, 114, 50);
    addButton ("Hautes tudes commerciales", 30, 355, 114, 50);
    addButton ("Sciences",  145, 355, 114, 50);
    addButton ("Medecine",  30, 403, 114, 50);

    /** the bottom 3 here don't exist yet, but when they're added to
     * the data file this will work */
    addButton ("Administration centrale", 30, 458, 229, 50);
    addButton ("Institutions annexes",    30, 510, 229, 50);
    addButton ("Services Independants",   30, 560, 229, 50);
    addButton ("Mots cles",               30, 610, 229, 55);
  }
}
