// Messages.java
// 25.03.96
//
// Initialization messages

package cybcerone.init;

import java.awt.Rectangle;
import java.awt.Color;
import java.awt.Graphics;
import java.util.Vector;
import java.util.Enumeration;

import cybcerone.utils.Appletlike;
import cybcerone.utils.IdPanel;
import cybcerone.utils.Fonts;

class Messages extends IdPanel {
  private static final Rectangle placement = new Rectangle(467, 458, 419, 165);
  
  private static final String id = "Messages";
  private static final String statusText = "Initialization log";

  private static final Color gray = new Color (127, 127, 127);
  private static final int maxSize = 8;
  private static final int startY = scale (20);
  private static final int yIncr = scale (20);

  private Vector messages;
  private int y;

  public Messages (Appletlike app) {
    super (id, statusText, app);
    reshape (placement);
    messages = new Vector ();
  }

  public void update (String newMessage) {
    messages.addElement (newMessage);
    if (messages.size() > maxSize)
      messages.removeElementAt (0);
    repaint ();
  }

  public void paint (Graphics g) {
    g.setColor (getBackground ());
    g.fillRect (0, 0, size().width, size().height);

    g.setColor (Color.white);
    g.setFont (Fonts.tinyFont);
    y = startY;
    for (Enumeration e = messages.elements ();
	 e.hasMoreElements ();) {
      g.drawString ((String)e.nextElement(), 10, y);
      y += yIncr;
    }
  }

}
