// TsolNumberImages.java
// 18.03.96
//
// class to hold the numbers 0-9, as well as the minutes and seconds symbols

package cybcerone.main;

import java.awt.Image;

import cybcerone.utils.Appletlike;
import cybcerone.utils.SuperPanel;

/**
 * The images of the numbers used on the TsolPanel.
 */
public class TsolNumImages {
  final public static int count = 12;

  private Image[] nums;
  private Image minutes;
  private Image seconds;

  // imagePath/#color.gif
  // imagePath/dot_color.gif
  // imagePath/dot2_color.gif
  public TsolNumImages (String imagePath, String color, 
			int priority, Appletlike app) {
    nums = new Image[10];
    
    for (int i = 0; i < 10; i++) {
      nums[i] = app.getImage (imagePath + i + color + ".gif", priority);
    }

    minutes = app.getImage (imagePath + "dot_" + color + ".gif", priority);
    seconds = app.getImage (imagePath + "dot2_" + color + ".gif", priority);
  }

  public Image getDigit (int digit) {
    return nums[digit];
  }

  public Image getMinutes () { return minutes; }
  public Image getSeconds () { return seconds; }

}

