// OrientPhotos.java
// 16.03.96
//
// the photos on the orient screen

package cybcerone.orient;

import java.awt.Rectangle;
import java.awt.Image;
import java.awt.Color;
import java.awt.Graphics;

import cybcerone.utils.Appletlike;
import cybcerone.utils.AnimatedPanel;

/**
 * Flips through photos of the selected building/region.
 */
class OrientPhotos extends AnimatedPanel {
  private static final Rectangle placement = new Rectangle(734, 200, 289, 193);

  private static final String id = "OrientPhotos";
  private static final String statusText = "Photos of the selected region";

  private static int beginDelay = 100;
  private static int delay = 3000;

  OrientPhotos (Appletlike app) {
    super (id, statusText, beginDelay, delay, app);
    reshape (placement);

    setBackground (Color.black);
  }

  void update (Maplike newMap) {
    stop ();

    Image frames[] = newMap.getPhotos ();
    if (frames != null) {
      setFrames (frames);
      if (isShowing ()) start ();
    } else
      setFrames (null);
  }
  
  public void paint (Graphics g) {
    super.paint (g);
    if (currentFrameImage == null)
      g.clearRect (0, 0, placement.width, placement.height);
  }
}
