// PersonKeypad.java
// 28.02.96
//
// the keypad on the personne screen

package cybcerone.person;

import cybcerone.utils.Appletlike;
import cybcerone.utils.EntryKeypad;

/**
 * The keypad for the person screen.
 */
class PersonKeypad extends EntryKeypad {
  private static final String id = "personKeypad";
  private static final String statusText = "Search for a name";

  private static final String bgFile = 
    PersonPanel.imagePath + "fond_clavier.gif";
  private static final String activeBgFile =
    PersonPanel.imagePath + "fond_clavier_rouge.gif";

  PersonKeypad (Appletlike app) {
    super (id, statusText, app);
    
    setBackground (bgFile, 5);
    setActiveBackground (activeBgFile, 5);

    makeButtons ();
  }

  /**
   * Map out the buttons used.
   */
  private void makeButtons () {
    int x = 24;
    int y = 259;
    int xIncr = 61;
    int yIncr = 51;

    int x1 = x;
    int x2 = x1 + xIncr;
    int x3 = x2 + xIncr;
    int x4 = x3 + xIncr;

    addButton (eraseChar, x1, y, xIncr * 4, yIncr);
    addButton (backspaceChar, 0, 0, 0, 0);
    
    y += yIncr;
    addButton (new Character ('A'), x1, y, xIncr, yIncr);
    addButton (new Character ('B'), x2, y, xIncr, yIncr);
    addButton (new Character ('C'), x3, y, xIncr, yIncr);
    addButton (new Character ('D'), x4, y, xIncr, yIncr);

    y += yIncr;
    addButton (new Character ('E'), x1, y, xIncr, yIncr);
    addButton (new Character ('F'), x2, y, xIncr, yIncr);
    addButton (new Character ('G'), x3, y, xIncr, yIncr);
    addButton (new Character ('H'), x4, y, xIncr, yIncr);

    y += yIncr;
    addButton (new Character ('I'), x1, y, xIncr, yIncr);
    addButton (new Character ('J'), x2, y, xIncr, yIncr);
    addButton (new Character ('K'), x3, y, xIncr, yIncr);
    addButton (new Character ('L'), x4, y, xIncr, yIncr);

    y += yIncr;
    addButton (new Character ('M'), x1, y, xIncr, yIncr);
    addButton (new Character ('N'), x2, y, xIncr, yIncr);
    addButton (new Character ('O'), x3, y, xIncr, yIncr);
    addButton (new Character ('P'), x4, y, xIncr, yIncr);

    y += yIncr;
    addButton (new Character ('Q'), x1, y, xIncr, yIncr);
    addButton (new Character ('R'), x2, y, xIncr, yIncr);
    addButton (new Character ('S'), x3, y, xIncr, yIncr);
    addButton (new Character ('T'), x4, y, xIncr, yIncr);

    y += yIncr;
    addButton (new Character ('U'), x1, y, xIncr, yIncr);
    addButton (new Character ('V'), x2, y, xIncr, yIncr);
    addButton (new Character ('W'), x3, y, xIncr, yIncr);
    addButton (new Character ('X'), x4, y, xIncr, yIncr);

    y += yIncr;
    addButton (new Character ('Y'), x1, y, xIncr, yIncr);
    addButton (new Character ('Z'), x2, y, xIncr, yIncr);
    addButton (new Character (' '), x3, y, xIncr * 2, yIncr);
  }
}
