// PersonPaper.java
// 28.02.96
//
// the paper on the personne screen

package cybcerone.person;

import cybcerone.utils.Appletlike;
import cybcerone.utils.ScrollingPaper;
import cybcerone.utils.PersonVector;

/**
 * The paper on the person screen.
 */
class PersonPaper extends ScrollingPaper implements Runnable {
  private static final String id = "personPaper";
  private static final String statusText = "Click for more information";

  private Thread updater;
  private String updateName;

  PersonPaper (Appletlike app) {
    super (id, statusText, app);
  }

  /**
   * Search for this name.
   */
  void update (String name) {
    if (updater != null)
      updater.stop ();

    updateName = name;
    updater = new Thread (this);
    updater.start ();
  }
    
  public void stop () {
    if (updater != null)
      updater.stop ();
    updater = null;
  }

  public void run () {
    int first, last;

    while (theData == null) {
      try {
	updater.sleep (1000);
      } catch (InterruptedException e) {
      }
    }

    PersonVector thePeople = new PersonVector (theData.toVector ());
    
    if (updateName.equals ("")) {
      first = 0;
      last = thePeople.size () - 1;
    } else {
      first = searchFirst (updateName, thePeople);
      last = searchLast (updateName, thePeople, first);
    }
    setDataRange (theData, first, last);
  }
  
  /** 
   * Find the first occurance of this name.
   */
  private int searchFirst (String name, PersonVector people) {
    int first = 0;
    int last = people.size () - 1;
    int current = 0;
    String personName = null;

    while (last > first) {
      current = (first + last) / 2;
      personName = people.elementAt(current).getNomCaps ();
      if (personName.startsWith (name)) {
        last = current;
      } else {
        if (personName.compareTo (name) < 0)
          first = current + 1;
        else
          last = current - 1;
      }
    }
    
    if (last == first) {
      current = first;
      personName = people.elementAt(current).getNomCaps ();
    }
    
    if (personName.startsWith (name)) {
      return current;
    } else {
      return -1;
    }
  }

  /** 
   * Find the last occurance of this name.
   */
  private int searchLast (String name, PersonVector people, int first) {
    int last = people.size () - 1;
    String personName = null;
    int current = 0;

    if (first >= 0) {
    
      while (last > first) {
        current = (first + last + 1) / 2;
        personName = people.elementAt(current).getNomCaps ();
        if (personName.startsWith (name)) {
          first = current;
        } else {
          if (personName.compareTo (name) < 0) {
            first = current + 1;
          } else {
            last = current - 1;
	  }
        }
      }
      if (first == last) current = first;
			  
      return current;
      
    } else {
      
      return (first - 1);
      
    }
  }
}

