// Appletlike.java
// 28.02.96
//
// provides some basic Applet-like functions

package cybcerone.utils;

import java.applet.Applet;
import java.awt.Image;

/**
 * This interface is a subset of useful Applet methods.
 */
public interface Appletlike {

  /**
   * Shows the given status on the status bar.
   */
  public void showStatus (String newStatus);

  /**
   * Retrieves the image in the specified filename, relative
   * to the document base.  By default uses the highest available
   * priority.
   */
  public Image getImage (String imageFileName);

  /** 
   * Same as above, but allows the caller to assign a priority.  Highest
   * priority is 0.
   */
  public Image getImage (String imageFileName, int priority);

  /**
   * Update yourself with this value.
   */
  public void update (Object updateValue);

  /**
   * Returns this panel's id.
   */
  public String getId ();

  /**
   * Get's data from a file.
   */
  public void getData (String fname, Literate reader, Appletlike requester);

  /**
   * Get's a Vector of Strings from a file.
   */
  public void getData (String fname, Appletlike requester);

  /**
   * Sets the cursor shape.
   */
  public void setCursor (int cursorType);

  /** Return to default state. */
  public void reset ();

  /** Print a message on the initialization screen. */
  public void initMessage (String message);
}
