// ManifVector.java
// 27.02.96
// 
// Puts a lot of typecasting in one place

package cybcerone.utils;

import java.util.Vector;
import java.util.Enumeration;


/**
 * A Vector of Manif objects.  See the comments for the
 * Vector class, they all apply.  The only difference is that it
 * only takes and returns Manif's.  Note: I didn't implement
 * the entire set of Vector methods, just the one's I use.  I would
 * have extended the Vector class, but most of its methods are final.
 *
 * @see Vector;
 * @see Manif;
 */
public class ManifVector {

  /* the real Vector behind the scenes */
  private Vector objects;

  public ManifVector () {
    objects = new Vector ();
  }

  public ManifVector (int initCapacity) {
    objects = new Vector (initCapacity);
  }

  /**
   * Converts a Vector into a ManifVector.
   */
  public ManifVector (Vector oldVector) {
    objects = oldVector;
  }

  public synchronized void addElement (Manif newElement) {
    objects.addElement (newElement);
  }

  public synchronized Manif elementAt (int index) {
    return (Manif)objects.elementAt (index);
  }

  public synchronized Manif firstElement () {
    return (Manif)objects.firstElement ();
  }

  public synchronized Manif lastElement () {
    return (Manif)objects.lastElement ();
  }

  /**
   * Ok, so the Manif type info is lost in the Enumeration. 
   */
  public synchronized Enumeration elements () {
    return objects.elements ();
  }

  public int size () {
    return objects.size ();
  }

  public boolean isEmpty () {
    return objects.isEmpty ();
  }

  public synchronized void removeElementAt (int index) {
    objects.removeElementAt (index);
  }

  public synchronized String toString () {
    return objects.toString ();
  }

  public synchronized Vector toVector () {
    return objects;
  }
}
