// Paintable.java
// 27.02.96
//
// Objects that know how to paint themselves

package cybcerone.utils;

import java.awt.Graphics;
import java.awt.image.ImageObserver;

/**
 * If it knows how to paint itself, it be Paintable.
 */
public interface Paintable {
  
  /**
   * The object will draw itself in the given Graphics context.  If
   * images are used, their ImageObserver will be linked to the one
   * passed in.  Depending on the object, the values of x and y may
   * be ignored or modified.
   */
  public void paint (Graphics g, int x, int y, ImageObserver observer);
}
