// Person.java
// 27.03.96
//
// the roots of the person class

package cybcerone.utils;

import java.awt.Graphics;
import java.awt.image.ImageObserver;
import java.io.DataInputStream;
import java.io.IOException;

/**
 * Someone affiliated with the University of Lausanne.
 */
public class Person implements Literate, Paintable, Mapable {
  private String nom;
  private String prenom;
  private String fonction;
  private String unite;
  private String faculte1;
  private String faculte2;
  private String batiment1;
  private String batiment2;
  private String batimentUnite;
  private String adresse1;
  private String adresse2;
  private String adresse3;
  private String adresse4;
  private String telephone;
  private String fax;

  private String nomCaps;
  private String separator;

  private static final int xOffset = Scaler.scale (15);
  private static final int x1 = Scaler.scale (320);
  private static final int x2 = Scaler.scale (550);

  /** for the reader */
  public Person () {
  }

  public Person (DataInputStream inStream) throws IOException {
    nom = inStream.readLine ();

    if (nom != null) {
      prenom = inStream.readLine ();
      fonction = inStream.readLine ();
      unite = inStream.readLine ();
      faculte1 = inStream.readLine ();
      faculte2 = inStream.readLine ();
      batiment1 = inStream.readLine ();
      batiment2 = inStream.readLine ();
      batimentUnite = inStream.readLine ();
      adresse1 = inStream.readLine ();
      adresse2 = inStream.readLine ();
      adresse3 = inStream.readLine ();
      adresse4 = inStream.readLine ();
      telephone = inStream.readLine ();
      fax = inStream.readLine ();

      separator = inStream.readLine ();
    }
  }

  public Object read (DataInputStream inStream) throws IOException {
    Person thePerson = new Person (inStream);

    if (thePerson.nom != null)
      return thePerson;
    else
      return null;
  }

  public String toString () {
    return ("Person[" + nom + ", " + prenom + "]");
  }

  public String getNom () { return nom; }
  public String getPrenom () { return prenom; }
  public String getFonction () { return fonction; }
  public String getUnite () { return unite; }
  public String getFaculte1 () { return faculte1; }
  public String getFaculte2 () { return faculte2; }
  public String getBatiment1 () { return batiment1; }
  public String getBatiment2 () { return batiment2; }
  public String getBatimentUnite () { return batimentUnite; }

  public String getAdresse () {
    String retVal = adresse1;
    if (adresse2 != null) retVal += " " + adresse2;
    if (adresse3 != null) retVal += " " + adresse3;
    if (adresse4 != null) retVal += " " + adresse4;
    
    return retVal;
  }

  public String getTelephone () { return telephone; }
  public String getFax () { return fax; }

  public String getNomCaps () {
    if (nomCaps == null)
      nomCaps = nom.toUpperCase ();
    return nomCaps;
  }

  public void paint (Graphics g, int x, int y, ImageObserver observer) {
    x += xOffset;
    g.drawString (nom, x, y);
    g.drawString (prenom, x + x1, y);
    g.drawString (telephone, x + x2, y);
  }

  public String getMapName () {
    if (batiment1.equals ("BFSH2"))
      return (batiment1 + "_" + batimentUnite.substring (0, 1));
    else
      return batiment1;
  }

  public String getZoneName () { return null; }
  
  public MapInfoPanel getMapInfoPanel (Appletlike app) {
    return new PersonInfoPanel (this, app);
  }
}
