// UniteVector.java
// 18.03.96
// 
// Puts a lot of typecasting in one place

package cybcerone.utils;

import java.util.Vector;
import java.util.Enumeration;


/**
 * A Vector of Unite objects.  See the comments for the
 * Vector class, they all apply.  The only difference is that it
 * only takes and returns Unite's.  Note: I didn't implement
 * the entire set of Vector methods, just the one's I use.  I would
 * have extended the Vector class, but most of its methods are final.
 *
 * @see Vector;
 * @see Unite;
 */
public class UniteVector {

  /* the real Vector behind the scenes */
  private Vector objects;

  public UniteVector () {
    objects = new Vector ();
  }

  public UniteVector (int initCapacity) {
    objects = new Vector (initCapacity);
  }

  /**
   * Converts a Vector into a UniteVector.
   */
  public UniteVector (Vector oldVector) {
    objects = oldVector;
  }

  public synchronized void addElement (Unite newElement) {
    objects.addElement (newElement);
  }

  public synchronized Unite elementAt (int index) {
    return (Unite)objects.elementAt (index);
  }

  public synchronized Unite firstElement () {
    return (Unite)objects.firstElement ();
  }

  public synchronized Unite lastElement () {
    return (Unite)objects.lastElement ();
  }

  /**
   * Ok, so the Unite type info is lost in the Enumeration. 
   */
  public synchronized Enumeration elements () {
    return objects.elements ();
  }

  public int size () {
    return objects.size ();
  }

  public boolean isEmpty () {
    return objects.isEmpty ();
  }

  public synchronized void removeElementAt (int index) {
    objects.removeElementAt (index);
  }

  public synchronized String toString () {
    return objects.toString ();
  }

  public synchronized Vector toVector () {
    return objects;
  }
}
